#---------------------------------------------------------------------------
#
#   SuPy GUI - Widget - Cocoa
#
#---------------------------------------------------------------------------

import AppKit as AK
from g_widget import GWidget
from ns import ns_rect, ns_unrect

class Widget(GWidget):
	#  _ns_view   NSView
	
	def __init__(self, _ns_view, _ns_inner_view = None, **kwds):
		_ns_view.setAutoresizingMask_(AK.NSViewMaxXMargin | AK.NSViewMaxYMargin)
		ns_inner = _ns_inner_view or _ns_view
		self._ns_view = _ns_view
		self._ns_inner_view = ns_inner
		GWidget.__init__(self, **kwds)
	
	def destroy(self):
		GWidget.destroy(self)
		self._ns_view = None
		self._ns_inner_view = None

	def get_bounds(self):
		return ns_unrect(self._ns_view.frame())
	
	def set_bounds(self, x):
		self._ns_view.setFrame_(ns_rect(x))
	
	def get_anchor(self):
		flags = []
		mask = self._ns_view.autoresizingMask()
		if not mask & AK.NSViewMinXMargin:
			flags.append('l')
		if not mask & AK.NSViewMinYMargin:
			flags.append('t')
		if not mask & AK.NSViewMaxXMargin:
			flags.append('r')
		if not mask & AK.NSViewMaxYMargin:
			flags.append('b')
		return "".join(flags)

	def set_anchor(self, flags):
		mask = 0
		if 'l' not in flags:
			mask |= AK.NSViewMinXMargin
		if 'r' not in flags:
			mask |= AK.NSViewMaxXMargin
		if 't' not in flags:
			mask |= AK.NSViewMinYMargin
		if 'b' not in flags:
			mask |= AK.NSViewMaxYMargin
		if 'l' in flags and 'r' in flags:
			mask |= AK.NSViewWidthSizable
		if 't' in flags and 'b' in flags:
			mask |= AK.NSViewHeightSizable
		self._ns_view.setAutoresizingMask_(mask)

	